package geoinformatics2;

import repast.simphony.context.*;
import repast.simphony.context.space.grid.*;
import repast.simphony.dataLoader.ContextBuilder;
import repast.simphony.engine.environment.*;
import repast.simphony.engine.schedule.*;
import repast.simphony.parameter.Parameters;
import repast.simphony.random.RandomHelper;
import repast.simphony.space.grid.*;
import repast.simphony.util.ContextUtils;
import static java.lang.Math.*;

public class DemographicsComplete extends DefaultContext implements ContextBuilder
{
	Context context;
	static int IMMIGRATION = 100;
	static double PROPORTIONAL_EMIGRATION = 0.0;
	int INITIAL_MATURES = 1000;

	public Context build( Context context )
	{
		System.err.println( "Setting context" + this.hashCode() + "-" + context.hashCode() );
		this.context = context;
		Parameters p = RunEnvironment.getInstance().getParameters();
		IMMIGRATION = (Integer) p.getValue( "immigration" );
		PROPORTIONAL_EMIGRATION = (Double) p.getValue( "proportionalEmigration" );
		INITIAL_MATURES = (Integer) p.getValue( "initialMatures" );
		
		
		for( int i = 0; i < INITIAL_MATURES; i++ )
			addAgent();
		RunState.getInstance().getScheduleRegistry().getModelSchedule().schedule( this );
		return context;
	}
	
	/**
	 * Hint: context.getRandomObjects( Agent.class, 10 ) will return 10 agents at random
	 * Hint: context.getObjects( Agent.class ).size() returns the total number of agents
	 * Hint: you can first make the assumption that only Matures are added to the system
	 * with random ages. Later, you can expand this to allow for Old and Young to immigrate.
	 */
	@ScheduledMethod(start=1,interval=1)
	public void migration()
	{
		/*
		int numAgents = context.getObjects( Agent.class ).size();
		for( int i = 0; i < IMMIGRATION; i++ )
			addMature();
		
		int emigration = min( numAgents-1, (int)(numAgents * PROPORTIONAL_EMIGRATION) );
		
		for( Object a : context.getRandomObjects( Agent.class, emigration ) )
			context.remove( a );
			*/
	}
	
	void addAgent()
	{
		if( context == null ) context = this;
		int age = RandomHelper.nextIntFromTo( 1, 100 );
		Agent a;
		if( age < Agent.MATURATION_AGE ) a = new Young();
		else if( age < Agent.OLD_AGE ) a = new Mature();
		else a = new Old();
			
		a.setAge( age );
		context.add( a );
	}
	void addMature()
	{
		if( context == null ) context = this;
		Agent m = new Mature();
		m.setAge( RandomHelper.nextIntFromTo( Agent.MATURATION_AGE, Agent.OLD_AGE ) );
		context.add( m );
	}
	
}
