package geoinformatics2;


import repast.simphony.context.Context;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.parameter.Parameters;
import repast.simphony.random.RandomHelper;

public class MatureComplete extends Agent
{
	public static double MORTALITY_RATE = 0.005;
	public static double BIRTH_RATE = 0.045;
	/**
	 * Init block - reads parameters from the model.score
	 */
	{
		Parameters p = RunEnvironment.getInstance().getParameters();
		MORTALITY_RATE = (Double) p.getValue( "matureMortality" );
		BIRTH_RATE = (Double) p.getValue( "birthRate" );
	}
	
	/**
	 * This method is called every timestep. 
	 */
	@ScheduledMethod( start=1,interval=1)
	public void update()
	{
		age++;
		if( age > OLD_AGE ) becomeOld();
		if( RandomHelper.nextDouble() < MORTALITY_RATE ) die();
		if( RandomHelper.nextDouble() < BIRTH_RATE ) giveBirth();
	}
	
	/**
	 * At this point, you should create a new Old agent with the
	 * correct age, and add it to the context (c.f. Young.mature() )
	 */
	void becomeOld()
	{
		Old old = new Old();
		old.setAge( age );
		getContext().add( old );
		die();
	}
	
	/**
	 * This method creates a new Young agent, and adds it to the context
	 */
	void giveBirth()
	{
		Agent y = new Young();
		Context c = getContext();
		if( c != null ) c.add( y );
	}
	
	/**
	 * This is used for the population graphs
	 */
	public int getType() {return MATURE_TYPE;}
}
