package geoinformatics2;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.parameter.Parameters;
import repast.simphony.random.RandomHelper;

public class Young extends Agent
{
	public static double MORTALITY_RATE = 0.01;
	/**
	 * Init block - reads parameters from the model.score
	 */
	{
		Parameters p = RunEnvironment.getInstance().getParameters();
		MORTALITY_RATE = (Double) p.getValue( "youngMortality" );
	}
	
	@ScheduledMethod( start=1,interval=1)
	public void update()
	{
		age++;
		if( age > MATURATION_AGE ) mature();
		if( RandomHelper.nextDouble() < MORTALITY_RATE ) die();
	}
	
	/**
	 * This creates a new Mature agent, sets the age correctly and adds it to the context,
	 * then gets rid of this agent.
	 * 
	 * HINT: You should do something similar for the transition from Mature to Old
	 */
	void mature()
	{
		Agent m = new Mature();
		m.setAge( age );
		getContext().add( m );
		die();
	}
	public int getType() {return YOUNG_TYPE;}
}
