package geoinformatics3.agents;


import geoinformatics3.CombinedModel;
import geoinformatics3.city.Cell;
import repast.simphony.context.Context;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.parameter.Parameters;
import repast.simphony.random.RandomHelper;

public class Mature extends Agent
{
	public static double MORTALITY_RATE = 0.005;
	public static double BIRTH_RATE = 0.045;
	public static double SATISFACTION_THRESHOLD = 0.8;
	
	public Mature( CombinedModel model )
	{
		super( model );
	}
	
	@ScheduledMethod( start=1,interval=1)
	public void update()
	{
		age++;
		if( age > OLD_AGE ) becomeOld();
		if( RandomHelper.nextDouble() < MORTALITY_RATE ) die();
		if( RandomHelper.nextDouble() < BIRTH_RATE ) giveBirth();
	}
	
	public Old becomeOld()
	{
		Old old = new Old( model );
		old.setAge( age );
		getContext().add( old );
		Cell loc = location;
		remove();
		if( loc != null )
		{
			old.moveOrEmigrate();
		}
		return old;
	}
	
	public Young giveBirth()
	{
		Young y = new Young( model );
		Context c = getContext();
		if( c != null ) c.add( y );
		y.location = location;
		return y;
	}
	
	public int getType() {return 1;}
	
	/**
	 * This function returns the agent's evaluation of the quality of a cell. Modify it to implement location preferences
	 * @param c
	 * @return
	 */
	public static double doEvaluation( Cell c )
	{
		return 0.6;
	}
	
}
