package geoinformatics3.agents;

import geoinformatics3.CombinedModel;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.parameter.Parameters;
import repast.simphony.random.RandomHelper;

public class Young extends Agent
{
	public Young( CombinedModel model )
	{
		super( model );
	}
	public static double MORTALITY_RATE = 0.01;
	/**
	 * Init block - reads parameters from the model.score
	 */
	{
		try{
		Parameters p = RunEnvironment.getInstance().getParameters();
		MORTALITY_RATE = (Double) p.getValue( "youngMortality" );
		} catch( Exception e )
		{
			System.err.println( "Could not find mature params in the parameters");
		}
	}
	
	@ScheduledMethod( start=1,interval=1)
	public void update()
	{
		age++;
		if( age > MATURATION_AGE ) mature();
		if( RandomHelper.nextDouble() < MORTALITY_RATE ) die();
	}
	
	public Mature mature()
	{
		Mature m = new Mature( model );
		m.setAge( age );
		getContext().add( m );
		m.moveOrEmigrate();
		remove();
		return m;
	}
	public int getType() {return 3;}
}
