package geoinformatics3.city;

import java.awt.Color;

/**
 * Displays the current population of the cell divided by it's capacity.
 * Fuller cells are cyan, empty cells are black
 * @author dave
 *
 */
public class CellCapacityRatioStyle extends AbstractCellStyle
{

	@Override
	Color getColor( Cell agent )
	{
		if( ! agent.isHabitable() ) return Color.gray;
		float popProp = (float)agent.getCapacityRatio();
		if( popProp > 1 ) popProp = 1;
		if( popProp < 0 ) popProp = 0;
		return new Color( 0f, popProp, popProp );
	}

}
