package geoinformatics3.city;

import geoinformatics3.agents.Mature;

import java.awt.Color;

/**
 * Displays the evaluation function that Mature agents are using, with
 * red being preferable, and blue being disliked
 * @author dave
 *
 */
public class CellMatureEvaluationStyle extends AbstractCellStyle
{

	@Override
	Color getColor( Cell agent )
	{
		if( ! agent.isHabitable() ) return Color.gray;
		float popProp = (float)Mature.doEvaluation( agent );
		if( popProp > 1 ) popProp = 1;
		if( popProp < 0 ) popProp = 0;
		return new Color( popProp, 0, 1-popProp );
	}

}
