package geoinformatics3.city;

import java.awt.Color;

/**
 * Displays the current cell population, as a proportion of the maximum allowed cell capacity
 * @author dave
 *
 */
public class CellPopulationStyle extends AbstractCellStyle
{

	@Override
	Color getColor( Cell agent )
	{
		if( ! agent.isHabitable() ) return Color.gray;
		float popProp = (float)agent.getPopulation() / Cell.MAX_CAPACITY;
		if( popProp > 1 ) popProp = 1;
		if( popProp < 0 ) popProp = 0;
		return new Color( 0f, popProp, popProp );
	}

}
