package geoinformatics3.city;

import java.awt.Color;

/**
 * Displays the average population/capacity in the neighbourhood of this cell
 * @author dave
 *
 */
public class CellSurroundingFullnessStyle extends AbstractCellStyle
{

	@Override
	Color getColor( Cell agent )
	{
		//if( ! agent.isHabitable() ) return Color.gray;
		float full = (float)agent.getNeighbourhoodCapacityRatio();
		if( full > 1 ) full = 1;
		if( full < 0 ) full = 0;
		if( agent.isHabitable() ) return new Color( full, 0f, 0f );
		return new Color( 0f, full, full );
	}

}
