package geoinformatics3.city;

import java.awt.Color;

/**
 * Displays the type of agent living in the cell, with red being Old
 * and green being Mature
 * @author dave
 *
 */
public class CellTypeStyle extends AbstractCellStyle
{

	@Override
	Color getColor( Cell agent )
	{
		if( ! agent.isHabitable() ) return Color.gray;
		float popProp = (float)agent.getNumMatures() / agent.getNumOlds();
		if( popProp > 1 ) popProp = 1;
		if( popProp < 0 ) popProp = 0;
		return new Color( popProp, 1-popProp, 0);
	}

}
