package geoinformatics4.agents;


import org.apache.tools.ant.types.optional.image.Scale.ProportionsAttribute;

import geoinformatics4.CombinedModel;
import geoinformatics4.city.Cell;
import repast.simphony.context.Context;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.parameter.Parameters;
import repast.simphony.random.RandomHelper;

public class Mature extends Agent
{
	public static double MORTALITY_RATE = 0.005;
	public static double BIRTH_RATE = 0.045;
	
	public Mature( CombinedModel model )
	{
		super( model );
	}
	
	public Mature( CombinedModel model, AgentType type )
	{
		super( model, type  );
	}
	
	@ScheduledMethod( start=1,interval=1)
	public void update()
	{
		age++;
		if( age > OLD_AGE ) becomeOld();
		if( RandomHelper.nextDouble() < MORTALITY_RATE ) die();
		if( RandomHelper.nextDouble() < BIRTH_RATE ) giveBirth();
	}
	
	public Old becomeOld()
	{
		Old old = new Old( model );
		old.setAge( age );
		old.setType( type );
		getContext().add( old );
		Cell loc = location;
		old.replaceInNetwork( this  );
		remove();
		if( loc != null )
		{
			old.moveOrEmigrate();
		}
		return old;
	}
	
	public Young giveBirth()
	{
		Young y = new Young( model );
		y.setType( type );
		Context c = getContext();
		if( c != null ) c.add( y );
		y.location = location;
		return y;
	}
	
	public double getDensityPreference( Cell c )
	{
		return c.getNeighbourhoodDensity() / Cell.CURRENT_MAXIMUM_CAPACITY;
	}
	
}
