package geoinformatics4.agents;

import geoinformatics4.CombinedModel;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.parameter.Parameters;
import repast.simphony.random.RandomHelper;

public class Young extends Agent
{
	public Young( CombinedModel model )
	{
		super( model );
		model.getDemographics().addNewborn( this );
	}
	public static double MORTALITY_RATE = 0.01;
	
	@ScheduledMethod( start=1,interval=1)
	public void update()
	{
		age++;
		if( age > MATURATION_AGE ) mature();
		if( RandomHelper.nextDouble() < MORTALITY_RATE ) die();
	}
	
	public Mature mature()
	{
		Mature m = new Mature( model );
		m.setAge( age );
		m.setType( type );
		getContext().add( m );
		m.moveOrEmigrate();
		m.replaceInNetwork( this );
		remove();
		return m;
	}
}
