package geoinformatics4.city;

import geoinformatics4.agents.*;

import java.awt.Color;

/**
 * Displays the type of agent living in the cell, with red being Old
 * and green being Mature
 * @author dave
 *
 */
public class CellEvaluationStyle extends AbstractCellStyle
{

	@Override
	Color getColor( Cell agent )
	{
		if( ! agent.isHabitable() ) return Color.gray;
		if( agent.getPopulation() == 0 ) return Color.gray;
		int num = 0;
		double tot = 0;
		for( Agent a : agent.getAgents() )
		{
			tot += a.evaluateCell( agent );
			num++;
		}
		float prop = (float)tot/num;
		if( prop < 0.0 ) prop = 0;
		if( prop > 1.0 ) prop = 1;
		return new Color( prop, 0, prop);
	}

}
