package geoinformatics4.city;

import geoinformatics4.agents.*;

import java.awt.Color;

/**
 * Displays the type of agent living in the cell, with red being Old
 * and green being Mature
 * @author dave
 *
 */
public class CellSocialStyle extends AbstractCellStyle
{

	@Override
	Color getColor( Cell agent )
	{
		if( ! agent.isHabitable() ) return Color.gray;
		if( agent.getPopulation() == 0 ) return Color.gray;
		Agent a = agent.getAgents().iterator().next();
		float prop = (float)a.getSocialPreference( agent );
		if( prop < 0.0 ) prop = 0;
		if( prop > 1.0 ) prop = 1;
		return new Color( 0, 0, prop);
	}

}
