package geoinformatics4.city;

import java.awt.Color;

/**
 * Displays the state of the cells, with:
 * NEW -> red
 * AVAILABLE -> yellow
 * EMPTY -> gray
 * OLD -> blue fading to grean as age approaches redevelopment age
 * @author dave
 *
 */
public class CellStateStyle extends AbstractCellStyle
{

	@Override
	Color getColor( Cell agent )
	{
		float ageProp = (float)agent.getAge()/Cell.REDEVELOPMENT_AGE;
		if( ageProp > 1 ) ageProp = 1;
		if( ageProp < 0 ) ageProp = 0;
		switch ( agent.getState() )
		{
		case NEW:
			return Color.red;
		case AVAILABLE:
			return Color.yellow;
		case OLD:
			return new Color( 0f, ageProp, 1-ageProp );
		case EMPTY:
			return Color.gray;
		default:
			return Color.black;
		}
	}

}
