package gi.city.display;

import gi.city.Cell;

import java.awt.Color;

/**
 * Displays the type of agent living in the cell, with red being all Matures
 * and green being all Olds
 * @author dave
 *
 */
public class CellAgeTypeStyle extends AbstractCellStyle
{

	@Override
	Color getColor( Cell agent )
	{
		if( ! agent.isHabitable() ) return Color.gray;
		float popProp = (float)agent.getNumMatures() / agent.getPopulation();
		if( popProp > 1 ) popProp = 1;
		if( popProp < 0 ) popProp = 0;
		return new Color( popProp, 1-popProp, 0);
	}

}
