package gi.raster;

import gi.CombinedModel;
import gi.city.Cell;

/**
 * Writes out a raster file indicating whether there are more Olds or Matures
 * in each cell (1 = majority of Matures, 3 = majority of Olds, 2 = equal numbers)
 * @author dmrust
 *
 */
public class AgeMajorityWriter extends RasterWriter
{

	public AgeMajorityWriter( CombinedModel model )
	{
		super( model );
	}

	@Override
	String generateFilename()
	{
		return "output/ageMajority.txt";
	}

	@Override
	String valueForCell( Cell c )
	{
		if( c.getPopulation() == 0 ) return getNodata();
		if( c.getNumMatures() >= c.getNumOlds() ) return "1";
		if( c.getNumMatures() == c.getNumOlds() ) return "2";
		return "3";
	}

}
