package gi.raster;

import gi.CombinedModel;
import gi.city.Cell;

/**
 * Writes out the proportion of mature agents in the cell. 1 = all matures, 0 = all olds
 * @author dmrust
 *
 */
public class AgeProportionWriter extends RasterWriter
{

	public AgeProportionWriter( CombinedModel model )
	{
		super( model );
	}

	@Override
	String generateFilename()
	{
		return "output/ageProportion.txt";
	}

	@Override
	String valueForCell( Cell c )
	{
		return ((float)c.getNumMatures()/c.getPopulation()) + "";
	}

}
