package gi.raster;

import gi.CombinedModel;
import gi.city.Cell;

/**
 * Writes out the id of the most prevalent agent type in the cell. See AgentType for ids.
 * @author dmrust
 *
 */
public class MajorityTypeWriter extends RasterWriter
{

	public MajorityTypeWriter( CombinedModel model )
	{
		super( model );
	}

	@Override
	String generateFilename()
	{
		return "output/majorityType.txt";
	}

	@Override
	String valueForCell( Cell c )
	{
		if( c.getPopulation() == 0 ) return getNodata();
		return c.getMajorityType().id + "";
	}

	@Override
	public String getNodata()
	{
		return "0";
	}
	

}
