package gi.raster;

import gi.CombinedModel;
import gi.city.*;

import java.io.*;

import repast.simphony.space.grid.Grid;

public abstract class RasterWriter
{
	CombinedModel model;
	City city;
	Grid<Cell> grid;
	int defaultXll = 502000;
	int defaultYll = 231000;
	int defaultCellSize = 250;
	
	public RasterWriter( CombinedModel model )
	{
		this.model = model;
		city = model.getCity();
		grid = city.getGrid();
	}
	
	abstract String generateFilename();
	abstract String valueForCell( Cell c );
	public String getNodata() { return "-9999"; }
	
	public void writeRaster() throws IOException
	{
		File f = new File( generateFilename() );
		if( f.exists() ) f.delete();
		if( ! f.createNewFile() ) System.err.println( "Could not create file for some reason!");
		PrintStream o = new PrintStream( f );
		//o = System.out;
		int size = city.getSize();
		o.println( "ncols " + size);
		o.println( "nrows " + size);
		o.println( "xllcorner " + defaultXll);
		o.println( "yllcorner " + defaultYll);
		o.println( "cellsize " + defaultCellSize);
		o.println( "NODATA_value " + getNodata() + "\n" );
		for( int i = 0; i < size; i++ )
		{
			for( int j = 0; j < size; j++ )
			{
				o.print( valueForCell( grid.getObjectAt( i, j ) ) );
				if( j < size-1 ) o.print(  " "  );
			}
			o.println();
		}
		o.close();
	}
}
