package gi;

import gi.agents.Mature;
import gi.city.*;

import org.junit.*;

import static java.lang.Math.abs;
import static org.junit.Assert.*;

public class FloodplainTest extends ModelTest
{

	@Test
	public void testFloodplains()
	{
		createRiver = true;
		City.RIVER_OFFSET = 0;
		createChangelessWorld( 20, true );
		Cell.INITIAL_CAPACITY = 10;
		city.reinitialiseCellCapacities();
		
		
		Cell[] cells = new Cell[20];
		for( int i = 0; i < 20; i++ )
			cells[i] = grid.getObjectAt( i, 0 );
		
		for( int i = 0; i < 20; i++ )
			assertEquals( i, cells[i].getDistanceToRiver(), 0.01 );
		
		assertEquals( 0, city.getPopulationIn100YearFloodplain() );
		assertEquals( 0, city.getPopulationIn50YearFloodplain() );
		
		cells[3].add( new Mature(model) );
		cells[3].add( new Mature(model) );
		assertEquals( 2, cells[3].getPopulation() );
		assertEquals( 0, city.getPopulationIn100YearFloodplain() );
		assertEquals( 0, city.getPopulationIn50YearFloodplain() );
		
		cells[2].add( new Mature(model) );
		assertEquals( 1, city.getPopulationIn100YearFloodplain() );
		assertEquals( 0, city.getPopulationIn50YearFloodplain() );
		cells[2].add( new Mature(model) );
		assertEquals( 2, city.getPopulationIn100YearFloodplain() );
		assertEquals( 0, city.getPopulationIn50YearFloodplain() );
		
		cells[1].add( new Mature(model) );
		assertEquals( 3, city.getPopulationIn100YearFloodplain() );
		assertEquals( 1, city.getPopulationIn50YearFloodplain() );
	}
}
